#ifndef M2IF_VECT_H
#define M2IF_VECT_H

#include <ostream>

namespace m2if {

class Vect
{
 private:
  int size_;
  double *data_;

 public: // structors
  Vect(int size);
  Vect(const Vect & v);
  ~Vect();

 public: // getters
  int size_get() { return size_; }
  int size_get() const { return size_; }
  double operator[](int i) const;

 public: // setters
  double & operator[](int i);

public: // assignment
  Vect & operator=(const Vect & v);

public: // math functions
  double norm();
};

std::ostream & operator<<(std::ostream & st, const Vect & v);
Vect operator+(const Vect & v1, const Vect & v2);
Vect operator-(const Vect & v1, const Vect & v2);
double operator*(const Vect & v1, const Vect & v2);

} // namespace m2if

#endif // M2IF_VECT_H
